<template>
	<div class="auxiliary-advice-container layout-pd">
		<el-card shadow="never">
			<el-form :model="state.queryParams" ref="ruleFormRef" inline @submit.native.prevent>
				<el-form-item label="意见类型" prop="CommonType">
					<el-select v-model="state.queryParams.CommonType" placeholder="请选择意见类型">
						<el-option v-for="item in commonType" :value="item.key" :key="item.key" :label="item.value" />
					</el-select>
				</el-form-item>
				<el-form-item label="常用语分类" prop="isOpen">
					<el-select v-model="state.queryParams.isOpen" placeholder="请选择意见类型">
						<el-option v-for="item in openState" :value="item.key" :key="item.key" :label="item.value" />
					</el-select>
				</el-form-item>
				<el-form-item>
					<el-button type="primary" @click="queryList" :loading="state.loading"> <SvgIcon name="ele-Search" class="mr5" />查询 </el-button>
					<el-button @click="resetQuery(ruleFormRef)" v-waves class="default-button"> <SvgIcon name="ele-Refresh" class="mr5" />重置 </el-button>
				</el-form-item>
			</el-form>
		</el-card>
		<el-card shadow="never">
			<ProTable
				ref="proTableRef"
				:columns="columns"
				:data="state.tableData"
				@updateTable="queryList"
				:loading="state.loading"
				:total="state.total"
				v-model:page-index="state.queryParams.PageIndex"
				v-model:page-size="state.queryParams.PageSize"
			>
				<!-- 表格 header 按钮 -->
				<template #tableHeader="scope">
					<el-button type="primary" @click="onAdviceAdd"> <SvgIcon name="ele-Plus" class="mr5" />新增 </el-button>
					<el-button type="primary" @click="onAdviceDelete" :disabled="!scope.isSelected"> <SvgIcon name="ele-Delete" class="mr5" />删除 </el-button>
				</template>
				<template #isOpen="{ row }">
					{{ row.isOpen ? '公开常用意见' : '个人常用意见' }}
				</template>
				<!-- 表格操作 -->
				<template #operation="{ row }">
					<el-button link type="primary" @click="updateAdvice(row)" v-auth="'auxiliary:advice:edit'" title="修改参数"> 修改 </el-button>
				</template>
			</ProTable>
		</el-card>
		<!--  常用意见新增  -->
		<advice-add ref="adviceAddRef" @updateList="queryList" :commonType="commonType" />
		<!--  常用意见编辑  -->
		<advice-edit ref="adviceEditRef" @updateList="queryList" :commonType="commonType" />
	</div>
</template>

<script lang="tsx" setup name="auxiliaryAdvice">
import { defineAsyncComponent, onMounted, reactive, ref } from 'vue';
import { ElButton, ElMessage, ElMessageBox, FormInstance } from 'element-plus';
import { formatDate } from '@/utils/formatTime';
import { commonBaseData, deleteCommon, publicCommonList } from '@/api/auxiliary/advice';

// 引入组件
const AdviceAdd = defineAsyncComponent(() => import('@/views/auxiliary/advice/component/Advice-add.vue')); // 常用意见新增
const AdviceEdit = defineAsyncComponent(() => import('@/views/auxiliary/advice/component/Advice-edit.vue')); // 常用意见编辑

const proTableRef = ref<RefType>(); // 表格ref
// 表格配置项
const columns = ref<any[]>([
	{ type: 'selection', fixed: 'left', width: 55 },
	{
		label: '意见内容',
		prop: 'content',
		width: 300,
	},
	{
		label: '意见类型',
		prop: 'commonTypeText',
		width: 130,
	},
	{
		label: '常用意见分类',
		prop: 'isOpen',
		width: 170,
	},
	{
		label: '创建人',
		prop: 'creatorName',
	},
	{
		label: '创建部门',
		prop: 'creatorOrgName',
	},
	{
		label: '创建时间',
		prop: 'creationTime',
		width: 170,
		render: ({ row }) => {
			return <span>{formatDate(row.creationTime, 'YYYY-mm-dd HH:MM:SS')}</span>;
		},
	},
	{ prop: 'operation', label: '操作', fixed: 'right', width: 140, align: 'center' },
]);
// 定义变量内容
const state = reactive({
	loading: false, // 加载状态
	queryParams: {
		// 查询参数
		PageIndex: 1,
		PageSize: 10,
		CommonType: null, // 常用意见类型
		isOpen: null, // 是否公开
	},
	total: 0, // 总条数
	tableData: [], // 表格数据
});
const ruleFormRef = ref<RefType>(null); // 表单ref
const commonType = ref<EmptyArrayType>([]); // 常用意见类型
const openState = ref<EmptyArrayType>([
	{
		key: true,
		value: '公开常用意见',
	},
	{
		key: false,
		value: '个人常用意见',
	},
]); // 是否公开
const getBaseData = async () => {
	try {
		const res = await commonBaseData();
		commonType.value = res.result?.commonType ?? [];
	} catch (error) {
		console.log(error);
	}
};
// 获取参数列表
const queryList = () => {
	state.loading = true;
	publicCommonList(state.queryParams)
		.then((res) => {
			state.loading = false;
			state.tableData = res.result.items ?? [];
			state.total = res.result.total ?? 0;
		})
		.finally(() => {
			state.loading = false;
		});
};
// 重置表单
const resetQuery = (formEl: FormInstance | undefined) => {
	if (!formEl) return;
	formEl.resetFields();
	queryList();
};
// 新增意见
const adviceAddRef = ref<RefType>(); // 意见新增
const onAdviceAdd = () => {
	adviceAddRef.value.openDialog();
};
// 修改意见
const adviceEditRef = ref<RefType>(); // 修改意见
const updateAdvice = (row: any) => {
	adviceEditRef.value.openDialog(row);
};
// 删除参数
const onAdviceDelete = () => {
	const contents = proTableRef.value.selectedList.map((item: any) => item.content).join('、');
	const ids = proTableRef.value.selectedList.map((item: any) => item.id);
	ElMessageBox.confirm(`您确定要删除：【${contents}】的常用意见，是否继续?`, '提示', {
		confirmButtonText: '确认',
		cancelButtonText: '取消',
		type: 'warning',
		draggable: true,
		cancelButtonClass: 'default-button',
		autofocus: false,
	})
		.then(() => {
			deleteCommon({ ids }).then(() => {
				ElMessage.success('操作成功');
				queryList();
			});
		})
		.catch(() => {});
};
// 页面加载时
onMounted(() => {
	getBaseData();
	queryList();
});
</script>
